Apache crashes with Redmine.pm and RedmineCacheCredsMax active

2020-03-12 13:24 - Dominik Bittl

Status: Resolved Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: SCM extra Estimated time: 0.00 hour

Target version:    

Resolution:  Affected version: 3.4.4

Description

Hello,

issue as described in the topic.

The Apache keeps crashing with Redmine.pm when RedmineCacheCredsMax is set.

- What infos do you need further? Is there a way to debug this?

System:

Ubuntu 18.04.4 LTS

Perl v5.26.1

#perl -V 

Summary of my perl5 (revision 5 version 26 subversion 1) configuration:

  Platform:

    osname=linux

    osvers=4.9.0

    archname=x86_64-linux-gnu-thread-multi

    uname='linux localhost 4.9.0 #1 smp debian 4.9.0 x86_64 gnulinux '

    config_args='-Dusethreads -Duselargefiles -Dcc=x86_64-linux-gnu-gcc -Dcpp=x86_64-linux-gnu-cpp

 -Dld=x86_64-linux-gnu-gcc -Dccflags=-DDEBIAN -Wdate-time -D_FORTIFY_SOURCE=2 -g -O2 -fdebug-prefi

x-map=/build/perl-hx1dVS/perl-5.26.1=. -fstack-protector-strong -Wformat -Werror=format-security -

Dldflags= -Wl,-Bsymbolic-functions -Wl,-z,relro -Dlddlflags=-shared -Wl,-Bsymbolic-functions -Wl,-

z,relro -Dcccdlflags=-fPIC -Darchname=x86_64-linux-gnu -Dprefix=/usr -Dprivlib=/usr/share/perl/5.2

6 -Darchlib=/usr/lib/x86_64-linux-gnu/perl/5.26 -Dvendorprefix=/usr -Dvendorlib=/usr/share/perl5 -

Dvendorarch=/usr/lib/x86_64-linux-gnu/perl5/5.26 -Dsiteprefix=/usr/local -Dsitelib=/usr/local/shar

e/perl/5.26.1 -Dsitearch=/usr/local/lib/x86_64-linux-gnu/perl/5.26.1 -Dman1dir=/usr/share/man/man1

 -Dman3dir=/usr/share/man/man3 -Dsiteman1dir=/usr/local/man/man1 -Dsiteman3dir=/usr/local/man/man3

 -Duse64bitint -Dman1ext=1 -Dman3ext=3perl -Dpager=/usr/bin/sensible-pager -Uafs -Ud_csh -Ud_ualar

m -Uusesfio -Uusenm -Ui_libutil -Ui_xlocale -Uversiononly -DDEBUGGING=-g -Doptimize=-O2 -dEs -Duse

shrplib -Dlibperl=libperl.so.5.26.1'

 
#dpkg -l |grep apache

ii  apache2                            2.4.29-1ubuntu4.12                  amd64        Apache HTT

P Server

ii  apache2-bin                        2.4.29-1ubuntu4.12                  amd64        Apache HTT

P Server (modules and other binary files)

ii  apache2-data                       2.4.29-1ubuntu4.12                  all          Apache HTT

P Server (common files)

ii  apache2-utils                      2.4.29-1ubuntu4.12                  amd64        Apache HTT

P Server (utility programs for web servers)

ii  libapache-dbi-perl                 1.12-1                              all          interface 

connecting apache server to database via perl's DBI

ii  libapache2-mod-perl2               2.0.10-2ubuntu3.18.04.1             amd64        Integratio

n of perl with the Apache2 web server

rc  libapache2-mod-shib2               2.6.1+dfsg1-2                       amd64        Federated 

web single sign-on system (Apache module)

ii  libapache2-mod-svn                 1.9.7-4ubuntu1                      amd64        Apache Sub

version server modules for Apache httpd
ii  libapache2-reload-perl             0.13-1                              all          module for

 reloading Perl modules when changed on disk

 
vhost:

      [...]

        <IfModule dav_svn_module>

        PerlLoadModule Apache::Redmine

        SVNCompressionLevel 0

        <Location /repos/>

                DAV svn

                SVNParentPath /var/opt/apache/XXX/subversion/

                SVNListParentPath on

                SVNIndexXSLT "/repos-web/view/repos.xsl" 

                SVNPathAuthz off

                SVNAllowBulkUpdates Prefer

                SVNCacheRevProps on

                PerlAccessHandler Apache::Authn::Redmine::access_handler

                PerlAuthenHandler Apache::Authn::Redmine::authen_handler

                AuthType Basic

                AuthName "Redmine SVN Repository" 

                AuthUserFile /dev/null

                Require all denied

                Require all denied

                <RequireAny>

                <RequireAny>

                        Require valid-user

                </RequireAny>

                <RequireAll>

                     Require method GET PROPFIND OPTIONS REPORT HEAD POST

                     <RequireAny>

                        Require ip XXXX

                        Require env AllowIP

                     </RequireAny>

                </RequireAll>

                </RequireAny>

                #limit max size to 400MB

                LimitRequestBody 424288000

                LimitXMLRequestBody 8000000

                ## for mysql

                RedmineDSN "DBI:mysql:database=XXX;host=XXX;port=XXXX" 

                RedmineDbUser "XXXX" 

                RedmineDbPass "XXXXXXXXXXXXXXXXXXXXXXXXXXX" 

                #Cache the last 50 auth entries

                RedmineCacheCredsMax 500

        </Location>

[...]

History

#1 - 2020-03-13 04:51 - Go MAEDA

- Category changed from Accounts / authentication to SCM extra

#2 - 2020-03-13 04:58 - Go MAEDA

- Description updated
Could you paste related errors in the logs of Apache here if you find any?

#3 - 2020-03-13 10:32 - Dominik Bittl

Sadly there are no logs, even with debug log level.

[Fri Mar 13 10:30:21.540225 2020] [ssl:info] [pid 20705:tid 139956984929216] AH01887: Init: Initializing (virtual) servers for SSL

[Fri Mar 13 10:30:21.543388 2020] [ssl:info] [pid 20705:tid 139956984929216] AH01876: mod_ssl/2.4.29 compiled against Server: Apache/2.4.29,

Library: OpenSSL/1.1.1

Then a timeout is reached and the apache start fails.

#4 - 2020-05-19 13:42 - Dominik Bittl

- Status changed from New to Resolved

I have switched the Apache module "mpm_event" to "mpm_prefork" no it works.
